require '_h2ph_pre.ph';

unless(defined(&_MACROS_H)) {
    eval 'sub _MACROS_H () {1;}' unless defined(&_MACROS_H);
    require 'sys/types.ph';
    require 'sys/stat.ph';
    if(defined(&__cplusplus)) {
    }
    eval 'sub numeric {
        local($c) = @_;
	    eval q((($c) >= ord(\'0\' && (c) <= \'9\')));
    }' unless defined(&numeric);
    eval 'sub max {
        local($a, $b) = @_;
	    eval q((($a) < ($b) ? ($b) : ($a)));
    }' unless defined(&max);
    eval 'sub min {
        local($a, $b) = @_;
	    eval q((($a) > ($b) ? ($b) : ($a)));
    }' unless defined(&min);
    eval 'sub abs {
        local($x) = @_;
	    eval q((($x) >= 0? ($x) : -($x)));
    }' unless defined(&abs);
    eval 'sub compare {
        local($str1, $str2) = @_;
	    eval q( &strcmp(($str1), ($str2)));
    }' unless defined(&compare);
    eval 'sub equal {
        local($str1, $str2) = @_;
	    eval q(( &strcmp(($str1), ($str2)) == 0));
    }' unless defined(&equal);
    eval 'sub length {
        local($str) = @_;
	    eval q( &strlen($str));
    }' unless defined(&length);
    eval 'sub size {
        local($str) = @_;
	    eval q(( &strlen($str) + 1));
    }' unless defined(&size);
    eval 'sub exists {
        local($file) = @_;
	    eval q(( &stat($file,  &Statbuf) < 0? 0:  ($Statbuf->{st_mode})));
    }' unless defined(&exists);
    eval 'sub SAVE {
        local($name, $place) = @_;
	    eval q({ \'int\' $place = $name;);
    }' unless defined(&SAVE);
    eval 'sub RSTR {
        local($name, $place) = @_;
	    eval q($name = $place; });
    }' unless defined(&RSTR);
    if(defined(&__STDC__)) {
	eval 'sub DEBUG {
	    local($var, $type) = @_;
    	    eval q( &fprintf( &stderr, $var \\"= %\\" $type \\"\\\\n\\", $var));
	}' unless defined(&DEBUG);
	eval 'sub SCCSID {
	    local($arg) = @_;
    	    eval q( &static \'char\'  $Sccsid[] = $arg);
	}' unless defined(&SCCSID);
    } else {
	eval 'sub DEBUG {
	    local($var, $type) = @_;
    	    eval q( &fprintf( &stderr, \\"var = %type\\\\n\\", $var));
	}' unless defined(&DEBUG);
	eval 'sub SCCSID {
	    local($arg) = @_;
    	    eval q( &static \'char\'  $Sccsid[] = \\"arg\\");
	}' unless defined(&SCCSID);
    }
    eval 'sub ERRABORT () {
        eval q( &_error() {  &abort(); });
    }' unless defined(&ERRABORT);
    eval 'sub NONBLANK {
        local($p) = @_;
	    eval q( &while (*($p) == ord(\' \' || *(p) == \'\\\\t\')) ($p)++);
    }' unless defined(&NONBLANK);
    if(defined(&__cplusplus)) {
    }
}
1;
