require '_h2ph_pre.ph';

unless(defined(&_SYS_TIME_H)) {
    eval 'sub _SYS_TIME_H () {1;}' unless defined(&_SYS_TIME_H);
    require 'sys/feature_tests.ph';
    if(defined(&__cplusplus)) {
    }
    if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__) || defined( &_XPG4_2)) {
	unless(defined(&_ASM)) {
	    unless(defined(&_TIME_T)) {
		eval 'sub _TIME_T () {1;}' unless defined(&_TIME_T);
	    }
	    unless(defined(&_SUSECONDS_T)) {
		eval 'sub _SUSECONDS_T () {1;}' unless defined(&_SUSECONDS_T);
	    }
	    if(defined( &_SYSCALL32)) {
		require 'sys/types32.ph';
		eval 'sub TIMEVAL32_TO_TIMEVAL {
		    local($tv, $tv32) = @_;
    		    eval q({ -> &tv_sec = ($tv32)-> &tv_sec; ($tv)-> &tv_usec = ($tv32)-> &tv_usec; });
		}' unless defined(&TIMEVAL32_TO_TIMEVAL);
		eval 'sub TIMEVAL_TO_TIMEVAL32 {
		    local($tv32, $tv) = @_;
    		    eval q({ -> &tv_sec = ($tv)-> &tv_sec; ($tv32)-> &tv_usec = ($tv)-> &tv_usec; });
		}' unless defined(&TIMEVAL_TO_TIMEVAL32);
		eval 'sub TIME32_MAX () { &INT32_MAX;}' unless defined(&TIME32_MAX);
		eval 'sub TIME32_MIN () { &INT32_MIN;}' unless defined(&TIME32_MIN);
		eval 'sub TIMEVAL_OVERFLOW {
		    local($tv) = @_;
    		    eval q((($tv)-> &tv_sec <=  &TIME32_MIN || ($tv)-> &tv_sec >=  &TIME32_MAX));
		}' unless defined(&TIMEVAL_OVERFLOW);
	    }
	}
    }
    if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	unless(defined(&_ASM)) {
	}
    }
    if(defined(&__cplusplus)) {
    }
    unless(defined(&_ASM)) {
	require 'sys/types.ph';
    }
    if(defined(&__cplusplus)) {
    }
    if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	eval 'sub DST_NONE () {0;}' unless defined(&DST_NONE);
	eval 'sub DST_USA () {1;}' unless defined(&DST_USA);
	eval 'sub DST_AUST () {2;}' unless defined(&DST_AUST);
	eval 'sub DST_WET () {3;}' unless defined(&DST_WET);
	eval 'sub DST_MET () {4;}' unless defined(&DST_MET);
	eval 'sub DST_EET () {5;}' unless defined(&DST_EET);
	eval 'sub DST_CAN () {6;}' unless defined(&DST_CAN);
	eval 'sub DST_GB () {7;}' unless defined(&DST_GB);
	eval 'sub DST_RUM () {8;}' unless defined(&DST_RUM);
	eval 'sub DST_TUR () {9;}' unless defined(&DST_TUR);
	eval 'sub DST_AUSTALT () {10;}' unless defined(&DST_AUSTALT);
	eval 'sub timerisset {
	    local($tvp) = @_;
    	    eval q((($tvp)-> &tv_sec || ($tvp)-> &tv_usec));
	}' unless defined(&timerisset);
	eval 'sub timercmp {
	    local($tvp, $uvp, $cmp) = @_;
    	    eval q((($tvp)-> &tv_sec $cmp ($uvp)-> &tv_sec || (($tvp)-> &tv_sec == ($uvp)-> &tv_sec  && ($tvp)-> &tv_usec $cmp ($uvp)-> &tv_usec)));
	}' unless defined(&timercmp);
	eval 'sub timerclear {
	    local($tvp) = @_;
    	    eval q(($tvp)-> &tv_sec = ($tvp)-> &tv_usec = 0);
	}' unless defined(&timerclear);
    }
    if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &_XPG4_2) || defined( &__EXTENSIONS__)) {
	eval 'sub ITIMER_REAL () {0;}' unless defined(&ITIMER_REAL);
	eval 'sub ITIMER_VIRTUAL () {1;}' unless defined(&ITIMER_VIRTUAL);
	eval 'sub ITIMER_PROF () {2;}' unless defined(&ITIMER_PROF);
	eval 'sub ITIMER_REALPROF () {3;}' unless defined(&ITIMER_REALPROF);
	unless(defined(&_ASM)) {
	    if(defined( &_SYSCALL32)) {
		eval 'sub ITIMERVAL32_TO_ITIMERVAL {
		    local($itv, $itv32) = @_;
    		    eval q({  &TIMEVAL32_TO_TIMEVAL(($itv)-> &it_interval, ($itv32)-> &it_interval);  &TIMEVAL32_TO_TIMEVAL(($itv)-> &it_value, ($itv32)-> &it_value); });
		}' unless defined(&ITIMERVAL32_TO_ITIMERVAL);
		eval 'sub ITIMERVAL_TO_ITIMERVAL32 {
		    local($itv32, $itv) = @_;
    		    eval q({  &TIMEVAL_TO_TIMEVAL32(($itv32)-> &it_interval, ($itv)-> &it_interval);  &TIMEVAL_TO_TIMEVAL32(($itv32)-> &it_value, ($itv)-> &it_value); });
		}' unless defined(&ITIMERVAL_TO_ITIMERVAL32);
		eval 'sub ITIMERVAL_OVERFLOW {
		    local($itv) = @_;
    		    eval q(( &TIMEVAL_OVERFLOW(($itv)-> &it_interval) ||  &TIMEVAL_OVERFLOW(($itv)-> &it_value)));
		}' unless defined(&ITIMERVAL_OVERFLOW);
	    }
	}
    }
    if((!defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	eval 'sub SEC () {1;}' unless defined(&SEC);
	eval 'sub MILLISEC () {1000;}' unless defined(&MILLISEC);
	eval 'sub MICROSEC () {1000000;}' unless defined(&MICROSEC);
	eval 'sub NANOSEC () {1000000000;}' unless defined(&NANOSEC);
    }
    unless(defined(&_ASM)) {
	if(defined(&_KERNEL)) {
	    require 'sys/time_impl.ph';
	    require 'sys/mutex.ph';
	    eval 'sub TICK_TO_SEC {
	        local($tick) = @_;
    		eval q((($tick) /  &hz));
	    }' unless defined(&TICK_TO_SEC);
	    eval 'sub SEC_TO_TICK {
	        local($sec) = @_;
    		eval q((($sec) *  &hz));
	    }' unless defined(&SEC_TO_TICK);
	    eval 'sub TICK_TO_MSEC {
	        local($tick) = @_;
    		eval q(( &msec_per_tick ? ($tick) *  &msec_per_tick : ($tick) /  &tick_per_msec));
	    }' unless defined(&TICK_TO_MSEC);
	    eval 'sub MSEC_TO_TICK {
	        local($msec) = @_;
    		eval q(( &msec_per_tick ? ($msec) /  &msec_per_tick : ($msec) *  &tick_per_msec));
	    }' unless defined(&MSEC_TO_TICK);
	    eval 'sub MSEC_TO_TICK_ROUNDUP {
	        local($msec) = @_;
    		eval q(( &msec_per_tick ? (($msec) == 0? 0: (($msec) - 1) /  &msec_per_tick + 1) : ($msec) *  &tick_per_msec));
	    }' unless defined(&MSEC_TO_TICK_ROUNDUP);
	    eval 'sub TICK_TO_USEC {
	        local($tick) = @_;
    		eval q((($tick) *  &usec_per_tick));
	    }' unless defined(&TICK_TO_USEC);
	    eval 'sub USEC_TO_TICK {
	        local($usec) = @_;
    		eval q((($usec) /  &usec_per_tick));
	    }' unless defined(&USEC_TO_TICK);
	    eval 'sub USEC_TO_TICK_ROUNDUP {
	        local($usec) = @_;
    		eval q((($usec) == 0? 0:  &USEC_TO_TICK(($usec) - 1) + 1));
	    }' unless defined(&USEC_TO_TICK_ROUNDUP);
	    eval 'sub TICK_TO_NSEC {
	        local($tick) = @_;
    		eval q((($tick) *  &nsec_per_tick));
	    }' unless defined(&TICK_TO_NSEC);
	    eval 'sub NSEC_TO_TICK {
	        local($nsec) = @_;
    		eval q((($nsec) /  &nsec_per_tick));
	    }' unless defined(&NSEC_TO_TICK);
	    eval 'sub NSEC_TO_TICK_ROUNDUP {
	        local($nsec) = @_;
    		eval q((($nsec) == 0? 0:  &NSEC_TO_TICK(($nsec) - 1) + 1));
	    }' unless defined(&NSEC_TO_TICK_ROUNDUP);
	    eval 'sub TICK_TO_TIMEVAL {
	        local($tick, $tvp) = @_;
    		eval q({  &clock_t  &__tmptck = ($tick); ($tvp)-> &tv_sec =  &TICK_TO_SEC( &__tmptck); ($tvp)-> &tv_usec =  &TICK_TO_USEC( &__tmptck -  &SEC_TO_TICK(($tvp)-> &tv_sec)); });
	    }' unless defined(&TICK_TO_TIMEVAL);
	    eval 'sub TICK_TO_TIMEVAL32 {
	        local($tick, $tvp) = @_;
    		eval q({  &clock_t  &__tmptck = ;  &time_t  &__tmptm =  &TICK_TO_SEC; -> &tv_sec =  &__tmptm; ($tvp)-> &tv_usec =  &TICK_TO_USEC( &__tmptck -  &SEC_TO_TICK( &__tmptm)); });
	    }' unless defined(&TICK_TO_TIMEVAL32);
	    eval 'sub TICK_TO_TIMESTRUC {
	        local($tick, $tsp) = @_;
    		eval q({  &clock_t  &__tmptck = ($tick); ($tsp)-> &tv_sec =  &TICK_TO_SEC( &__tmptck); ($tsp)-> &tv_nsec =  &TICK_TO_NSEC( &__tmptck -  &SEC_TO_TICK(($tsp)-> &tv_sec)); });
	    }' unless defined(&TICK_TO_TIMESTRUC);
	    eval 'sub TICK_TO_TIMESTRUC32 {
	        local($tick, $tsp) = @_;
    		eval q({  &clock_t  &__tmptck = ;  &time_t  &__tmptm =  &TICK_TO_SEC; -> &tv_sec =  &__tmptm; ($tsp)-> &tv_nsec =  &TICK_TO_NSEC( &__tmptck -  &SEC_TO_TICK( &__tmptm)); });
	    }' unless defined(&TICK_TO_TIMESTRUC32);
	    eval 'sub TIMEVAL_TO_TICK {
	        local($tvp) = @_;
    		eval q(( &SEC_TO_TICK(($tvp)-> &tv_sec) +  &USEC_TO_TICK(($tvp)-> &tv_usec)));
	    }' unless defined(&TIMEVAL_TO_TICK);
	    eval 'sub TIMESTRUC_TO_TICK {
	        local($tsp) = @_;
    		eval q(( &SEC_TO_TICK(($tsp)-> &tv_sec) +  &NSEC_TO_TICK(($tsp)-> &tv_nsec)));
	    }' unless defined(&TIMESTRUC_TO_TICK);
	    if(defined( &_SYSCALL32)) {
	    }
	}
	if((!defined( &_KERNEL)  && !defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	    if(defined( &__STDC__)) {
	    } else {
	    }
	}
	if((!defined( &_KERNEL)  && !defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__) || defined( &_XPG4_2)) {
	    if(defined( &__STDC__)) {
		if(defined( &_XPG4_2)) {
		} else {
		}
	    } else {
	    }
	}
	if((!defined( &_KERNEL)  && !defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	    if(defined( &__STDC__)) {
		if(defined( &_SVID_GETTOD)) {
		} else {
		}
	    } else {
	    }
	}
	if((!defined( &_KERNEL)  && !defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__) || defined( &_XPG4_2)) {
	    if(defined( &__STDC__)) {
		if(defined( &_SVID_GETTOD)) {
		} else {
		}
	    } else {
	    }
	}
	if((!defined( &_KERNEL)  && !defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__)) {
	    require 'time.ph';
	}
	if((!defined( &_KERNEL)  && !defined( &_POSIX_C_SOURCE)  && !defined( &_XOPEN_SOURCE)) || defined( &__EXTENSIONS__) || defined( &_XPG4_2)) {
	    require 'sys/select.ph';
	}
    }
    if(defined(&__cplusplus)) {
    }
}
1;
